#include <Windows.h>
#include <dinput.h>
#include <list>
#include <map>
#include <set>
#include <stdio.h>
#include <tlhelp32.h>
#include <vector>

#include <d3d9.h>

#pragma once

void* EntryPoints[14];

uint32_t nSeed = 0;
uint32_t nDrawCalls = 0;
BOOL	 bCapture = FALSE;
BOOL     bShowInfo = FALSE;
BOOL     bChange = FALSE;

#pragma pack(1)
typedef struct _JMPCODE
{
    BYTE jmp;
    DWORD addr;
}JMPCODE, * PJMPCODE;



void PatchA(LPVOID address, const void* dwValue, SIZE_T dwBytes)
{
   unsigned long oldProtect;
   VirtualProtect((void*)address, dwBytes, PAGE_EXECUTE_READWRITE, &oldProtect);
   FlushInstructionCache(GetCurrentProcess(), (void*)address, dwBytes);
   memcpy((void*)address, dwValue, dwBytes);
   VirtualProtect((void*)address, dwBytes, oldProtect, &oldProtect);
}

bool CompareByteArray(PBYTE Data, PBYTE Signature)
{
    for (; *Signature; ++Signature, ++Data)
    {
        if (*Signature == '\x00')
        {
            continue;
        }
        if (*Data != *Signature)
        {
            return false;
        }
    }
    return true;
}

PBYTE FindSignature(PBYTE BaseAddress, DWORD ImageSize, PBYTE Signature)
{
    BYTE First = Signature[0];
    PBYTE Max = BaseAddress + ImageSize - strlen((PCHAR)Signature);

    for (; BaseAddress < Max; ++BaseAddress)
    {
        if (*BaseAddress != First)
        {
            continue;
        }
        if (CompareByteArray(BaseAddress, Signature))
        {
            return BaseAddress;
        }
    }
    return NULL;
}

ULONG GetImageSize(HANDLE ImageBase)
{
    IMAGE_DOS_HEADER* pDOSHeader = (IMAGE_DOS_HEADER*)ImageBase;
    IMAGE_NT_HEADERS* pNTHeaders = (IMAGE_NT_HEADERS*)((BYTE*)pDOSHeader + pDOSHeader->e_lfanew);
    return pNTHeaders->OptionalHeader.SizeOfImage;
}

void InitHooks()
{
    PCHAR Pattern = "\x0F\xA2\x89\x45\xF8\x83\x7D\xF8\x02";
    HANDLE hMod = GetModuleHandle(NULL);
    DWORD szModule = GetImageSize(hMod);

    DWORD addrToPatch = (DWORD)FindSignature((PBYTE)hMod, szModule, (PBYTE)Pattern);

    PatchA((LPVOID)addrToPatch, "\x0F\xA2\x89\x45\xF8\x90\x90\x90\x90\xE9\x02\x01\x00\x00\x90", 15);
}

// Entry point
extern "C" BOOL WINAPI DllMain(HINSTANCE hInst, DWORD reason, LPVOID v)
{
   // Proxy DLL is being attached
   if (reason == DLL_PROCESS_ATTACH) {
      char szPath[MAX_PATH];
      InitHooks();

      // Load direct input module

      if (!GetSystemDirectory(szPath, sizeof(szPath) - 20)) return FALSE;
      strcat(szPath, "\\d3d9.dll");
      auto mDirect3DModule = LoadLibrary(szPath);

      // Direct input module couldn't be loaded
      if (!mDirect3DModule) {
         // Report to caller that we failed to initialize our own module
         return FALSE;
      }


      EntryPoints[0] = GetProcAddress(mDirect3DModule, "D3DPERF_BeginEvent");
      EntryPoints[1] = GetProcAddress(mDirect3DModule, "D3DPERF_EndEvent");
      EntryPoints[2] = GetProcAddress(mDirect3DModule, "D3DPERF_GetStatus");
      EntryPoints[3] = GetProcAddress(mDirect3DModule, "D3DPERF_QueryRepeatFrame");
      EntryPoints[4] = GetProcAddress(mDirect3DModule, "D3DPERF_SetMarker");
      EntryPoints[5] = GetProcAddress(mDirect3DModule, "D3DPERF_SetOptions");
      EntryPoints[6] = GetProcAddress(mDirect3DModule, "D3DPERF_SetRegion");
      EntryPoints[7] = GetProcAddress(mDirect3DModule, "DebugSetLevel");
      EntryPoints[8] = GetProcAddress(mDirect3DModule, "DebugSetMute");
      EntryPoints[9] = GetProcAddress(mDirect3DModule, "Direct3DCreate9");
      EntryPoints[10] = GetProcAddress(mDirect3DModule, "Direct3DCreate9Ex");
      EntryPoints[11] = GetProcAddress(mDirect3DModule, "Direct3DShaderValidatorCreate9");
      EntryPoints[12] = GetProcAddress(mDirect3DModule, "PSGPError");
      EntryPoints[13] = GetProcAddress(mDirect3DModule, "PSGPSampleTexture");
   }

   // Proxy DLL is being detached
   if (reason == DLL_PROCESS_DETACH) {
   }

   // We successfully initialized our module
   return TRUE;
}

VOID __declspec(naked) __declspec(dllexport) D3DPERF_BeginEvent()
{
	__asm jmp dword ptr[EntryPoints + 0];
}

VOID __declspec(naked) __declspec(dllexport) D3DPERF_EndEvent(int)
{
	__asm jmp dword ptr[EntryPoints + 4];
}

VOID __declspec(naked) __declspec(dllexport) D3DPERF_GetStatus(int)
{
	__asm jmp dword ptr[EntryPoints + 8];
}

VOID __declspec(naked) __declspec(dllexport) D3DPERF_QueryRepeatFrame(int)
{
	__asm jmp dword ptr[EntryPoints + 12];
}

VOID __declspec(naked) __declspec(dllexport) D3DPERF_SetMarker()
{
	__asm jmp dword ptr[EntryPoints + 16];
}

VOID __declspec(naked) __declspec(dllexport) D3DPERF_SetOptions()
{
	__asm jmp dword ptr[EntryPoints + 20];
}

VOID __declspec(naked) __declspec(dllexport) D3DPERF_SetRegion()
{
	__asm jmp dword ptr[EntryPoints + 24];
}

VOID __declspec(naked) __declspec(dllexport) DebugSetLevel()
{
	__asm jmp dword ptr[EntryPoints + 28];
}

VOID __declspec(naked) __declspec(dllexport) DebugSetMute()
{
	__asm jmp dword ptr[EntryPoints + 32];

}VOID __declspec(naked) __declspec(dllexport) Direct3DCreate9()
{
	__asm jmp dword ptr[EntryPoints + 36];
}

VOID __declspec(naked) __declspec(dllexport) Direct3DCreate9Ex()
{
	__asm jmp dword ptr[EntryPoints + 40];
}

VOID __declspec(naked) __declspec(dllexport) Direct3DShaderValidatorCreate9()
{
	__asm jmp dword ptr[EntryPoints + 44];
}

VOID __declspec(naked) __declspec(dllexport) PSGPError()
{
	__asm jmp dword ptr[EntryPoints + 48];
}

VOID __declspec(naked) __declspec(dllexport) PSGPSampleTexture()
{
	__asm jmp dword ptr[EntryPoints + 52];
}